################################################################################
###     Minicurso de R (V Semana de Cincias Atuariais e Estatstica - UFRJ)
################################################################################

#===============================================================================
# AULA 2
#===============================================================================

# criando vetores (concatenao)

x <- c(10,22,35,15,33,45,12,23,34,56,77,12,11,10)   # vetor numrico geral

plot(x,type="l")

x <- x[-1]   # vetor sem o primeiro elemento

x[5] <- NA   # posio 3 do vetor recebe NA = missing value

plot(x,type="l")

###

x <- c(1,2,3,4,5)
y <- c(3,3,3,3,3)

z <- x + y

z <- x*y   # no  um produto vetorial

z <- exp(x)

###

a <- c("bola","casa","hadouken")   # vetor de nomes

barplot(c(4,3,12),names.arg=a)

pie(c(4,3,12),labels=a)

###

b <- c(TRUE,FALSE,FALSE)   # vetor lgico

b <- c(5==5,5>6,4!=4)   # vetor lgico

x[c(1,4,5)]   # posies 1, 4 e 5 do vetor

# criando vetores (sequncia)

x <- 1:10

x <- -5:15

###

a <- seq(1,10,by=0.5)   # sequncia de 1 a 10 de 0,5 em 0,5

b <- seq(1,10,length=19)   # sequncia de 1 a 10 de tamanho 19

###

x <- seq(-4,4,length=10)   # criando uma grade
y <- 1/(2*pi)*exp(-1/2*x^2)   # criando valores da funo

plot(x,y)   # "diagrama de disperso"

plot(x,y,type="l")   # curva da densidade da N(0,1)

###

mu <- mean(speed)
sigma <- sd(speed)

hist(speed,prob=TRUE)

lines(density(speed))

x <- seq(0,25,length=1000)
y <- 1/sqrt(2*pi*sigma^2)*exp(-1/(2*sigma^2)*(x - mu)^2)

lines(x,y)

# criando vetores (repetio)

x <- rep(1,times=10)

x <- rep(c(1,2,3),times=3)

x <- rep(c(1,3),times=c(8,9))

x <- rep(c(1,5),each=5)

x <- rep(1:4,each=2,times=3)

a <- rep(c("a","b"),times=2,each=3)

# criando vetores (comandos)

x <- c(10,12,32,14,10,11,11,23)

which(x==10)   # posies dos elementos iguais a 10

which(x<=20)   # posies dos elementos menores ou iguais a 20

sum(x)

prod(x)

exp(sum(log(x)))

# criando matrizes

A <- matrix(1:16,nrow=4,ncol=4)   # V

A <- matrix(1:16,nrow=4,ncol=4,byrow=TRUE) # >

A[1:3,c(1,4)]   # selecionando elementos especficos

A <- matrix(5,10,20)

A <- matrix(NA,10,20)

A[1,4] <- 5

###

B <- diag(4,5)

B <- diag(c(1,2,3,4,5,10))

###

A <- matrix(c(2,3,4,5,2,3),3,2)

B <- matrix(9,3,2)

C <- rbind(A,B)   # empilha matrizes

D <- cbind(A,B)   # alinha matrizes

###

A <- matrix(c(2,1,1,1,3,1,1,5,1),3,3)

dim(A)

det(A)

t(A)

###

B <-  matrix(5,3,3)

C <- A*B   # produto elemento-a-elemento

D <- A%*%B   # produto matricial

E <- A^(-1)   # inverso de cada elemento

F <- solve(A)   # matriz inversa

auto <- eigen(A)

###

names(auto)

valores <- auto$values   # autovalores
vetores <- auto$vectors   # autovetores

# criando arrays

A <- array(1:24,dim=c(2,3,4))

A[1,2,3]

A[1,2,]   # posies (1,2) de todas as matrizes

A[,,1]   # primeira matriz

# criando data.frames

dados <- data.frame(c(27,18,23),c("Ana","Eva","Mel"))   # criando data frame

names(dados) <- c("Idade","Nome")   # nomeando colunas do data frame

dados <- data.frame(Idade=c(27,18,23),Nome=c("Ana","Eva","Mel"))   # criando data frame com colunas nomeadas

attach(dados)   # habilitando o uso do nome das colunad do data frame

###

is.matrix(iris)

is.vector(iris)

is.numeric(iris)

is.data.frame(iris)

x <- iris[,1:4]

is.data.frame(x)

is.matrix(x)

y <- as.matrix(x)

is.matrix(y)

is.data.frame(y)

# criando listas

lista <- list(c(1,2,3),matrix(2,4,3),c("leite","ovos","cereal","miojo"))

lista[[1]]   # primeiro objeto

lista[[2]]   # segundo objeto

lista[[3]]   # terceiro objeto

is.vector(lista[[1]])

is.matrix(lista[[2]])

is.vector(lista[[3]])

lista[1]

lista[2]

lista[3]

is.list(lista[1])   # primeiro objeto como lista

is.list(lista[2])   # segundo objeto como lista

is.list(lista[3])   # terceiro objeto como lista

###

names(lista) <- c("vetor","matriz","compras")   # nomeando objetos na lista

lista <- list(vetor=c(1,2,3),matriz=matrix(2,4,3),compras=c("leite","ovos","cereal","miojo"))

lista$vetor

lista$ matriz

lista$compras

# salvando dados

A <- matrix(5:20,4,4)   # criando matriz
A <- as.data.frame(A)   # transformando em data frame

x <- c("a","b","c","d")   # acrescentando colunas

B <- cbind(A,x)   # alinhando A e x

write.table(B,"meudataframe.txt")   # salvando dados em .txt

write.csv(B,"meudataframe.csv")   # salvando dados em .csv

B2 <- read.table("meudataframe.txt")   # relendo arquivo .txt

B3 <- read.csv("meudataframe.csv")   # relendo arquivo .csv  (cuidado!)

###

write.table(B,"meudataframe.txt",row.names=FALSE,col.names=FALSE)   # salvando dados em .txt

write.csv(B,"meudataframe.csv",row.names=FALSE)   # salvando dados em .csv

B4 <- read.table("meudataframe.txt")   # relendo arquivo .txt

B5 <- read.csv("meudataframe.csv")   # relendo arquivo .csv  (aeeehhh!)

# distribuies de probabilidade

dbinom(5,10,0.5)   # P(X=5); X ~ Bin(10,0.5)

choose(10,5)*0.5^5*0.5^5

dpois(10,15)   # P(X=10); X ~ Poi(15)

exp(-15)*15^10/factorial(10)

###

x <- seq(0,20,length=100)
y <- dnorm(x,10,sqrt(25))

plot(x,y,type="l")

x <- seq(0,20)
y <- dchisq(x,2)

plot(x,y,type="l")

###

pnorm(10,5,sqrt(10))   # P(X <= 10); X ~ (5,10)

pnorm(10,5,sqrt(10)) - pnorm(5,10,sqrt(10))   # P(5 < X <= 10); X ~ N(5,10)

###

x <- rnorm(100,0,1)

hist(x,prob=TRUE)
lines(density(x))

grade <- seq(-10,10,length=100)

lines(grade,dnorm(grade,0,1),type="l")

y <- rt(100,10)

hist(y,prob=TRUE)
lines(density(y))

lines(grade,dt(grade,10),type="l")

# exerccio

u <- runif(500)   # sorteando X ~ Exp(5)
x <- -log(1-u)/5

# inferncia

x <- rnorm(100,10,sqrt(16))

teste1 <- t.test(x,conf.level=0.90,mu=10,alternative="two.sided")   # testando mdia

teste2 <- t.test(x,conf.level=0.95,mu=5,alternative="two.sided")

interconf <- teste2$conf.int

pvalor <- teste2$p.value

estatteste <- teste2$statistic

###

x <- rbinom(1,100,0.5)

teste3 <- prop.test(x,100,conf.level=0.90,p=0.5,alternative="two.sided")   # testando proporo

teste4 <- prop.test(x,100,conf.level=0.95,p=0.8,alternative="two.sided")

interconf <- teste4$conf.int

pvalor <- teste4$p.value

estatteste <- teste4$statistic