################################################################################
###     Minicurso de R (V Semana de Cincias Atuariais e Estatstica - UFRJ)
################################################################################

#===============================================================================
# AULA 3
#===============================================================================

# funes

minhalindafuncao <- function(){   # exemplo de funco sem argumentos
  print("Ahh, que belo dia!")
}

minhalindafuncao2 <- function(dia){   # exemplo de funo com argumentos
  aux <- 32 - dia
  print(paste("Faltam ",aux,"dias para o Ano Novo!"))
}

###

distancia <- function(x,y){   # calcula distncia euclidiana entre dois pontos
  d <- sqrt((y[1] - x[1])^2 + (y[2] - x[2])^2)
  return(d)
}

x <- c(5,10)
y <- c(-3,17)

distancia(x,y)

###

bhaskara <- function(a,b,c){
  x1 <- (-b - sqrt(b^2 - 4*a*c))/(2*a)
  x2 <- (-b + sqrt(b^2 - 4*a*c))/(2*a)
  x <- list(sol1=x1,sol2=x2)
  return(x)
}

x <- bhaskara(1,4,2)

x$sol1
x$sol2
  
# loopings e condicionamento (if-else)

x <- rnorm(100,10,5)   # exemplo de if

if(mean(x) > 10){
  print("Mdia maior que 10")
}

###

x <- rnorm(100,10,5)   # exemplo de if-else

if(mean(x) > 10){
  print("Mdia MAIOR que 10")
} else{
    print("Mdia MENOR que 10")
}

###

x <- 5   # exemplo de &&
if((x>=3)&&(x<7)){
  print("Aluno vai pra final!")
} else{
    print("Aprovado ou reprovado?")
}

result <- function(p1,p2,p3,exe.extra){   # funo resultado usando &&
  med <- mean(c(p1,p2,p3))
  if(exe.extra==TRUE){
    med <- med + 0.5
  }
  if(med<3){
    print(paste("Aluno(a) reprovado com mdia ",round(med,1),"!"))
  } else{
      if((med>=3)&&(med<7)){
        print(paste("Aluno(a) vai fazer prova final com mdia parcial ",round(med,1),"!"))
      } else{
          print(paste("Aluno(a) aprovado com mdia ",round(med,1),"!"))
      }
  }
}

# loopings e condicionamento (for)

for(i in 1:10){
  print(i)
}

for(i in c(1,2,5)){
  print(i)
}

for(i in -5:5){
  x <- rpois(1,5)
  print(x)
}

###

A <- matrix(rnorm(16,5,5),4,4)   # calculando trao de matriz

traco <- 0
d <- dim(A)[1]

for(i in 1:d){
  traco <- traco + A[i,i]
}

# exerccio

y <- rep(NA,length=100)   # modelo AR(1)
y[1] <- rnorm(1)
for(i in 2:100){
  y[i] <- y[i-1] + rnorm(1)
}

plot(y,type="l")

###

probexp <- function(a,b,beta,preci){   # integrao de monte carlo
  x <- rexp(preci,beta)
  prop <- 0
  for(i in 1:preci){
    if((x[i]>=a)&&(x[i]<=b)){
      prop <- prop + 1
    }
  }
  est <- prop/preci
  return(est)
}

probexp(0.5,2,0.1,1000)

pexp(2,0.1) - pexp(0.5,0.1)

###

x <- seq(0,1,length=100)
y <- sqrt(1 - x^2)
plot(x,y,type="l",xlim=c(0,1),ylim=c(0,1))

picalc <- function(prec){   # estimando pi
  x <- runif(prec)
  y <- runif(prec)
  soma <- 0
  for(i in 1:prec){
    if(y[i]<sqrt(1-x[i]^2)){
      soma <- soma + 1
    }
  }
  est <- 4*soma/prec
  return(est)
}

# loopings e condicionamento (while)

A <- matrix(rnorm(16,5,5),4,4)   # calculando trao de matriz

traco <- 0
d <- dim(A)[1]

i <- 1
while(i<=d){
  traco <- traco + A[i,i]
  i <- i + 1
}

# comandos grficos

plot(1,xlab=expression(alpha[t]),ylab=expression(beta[t]^2))

demo(plotmath)   # demonstrao do expression

demo(graphics)   # demosntrao de grficos

# exerccio

x <- rnorm(100)

hist(x,prob=TRUE,col=2,main="Meu Histograma Maneiro",xlab="Valores",ylab="Densidade",cex.axis=2,cex.lab=2,font=10,cex.main=2,
font.main=12)

plot(x,type="l",col=2,main="Minha Querida Srie",xlab="Tempo",ylab="Valores",lty=2,lwd=3,cex.axis=2,cex.lab=2,font=9,cex.main=2,
font.main=7)

# comandos grficos (voltando...)

x1 <- rnorm(10)
x2 <- rexp(10,5)
x3 <- rpois(10,2)
x4 <- rgamma(10,1,1)

par(mfrow=c(2,2),mar=c(2,2,1,2),bg="light blue",pch=2,lwd=3)   # exemplo de par

plot(x1)
plot(x2)
plot(x3)
plot(x4)

###

x <- rnorm(5,10,5)

plot(x,axes=FALSE,xlab="i",ylab=expression(x[i]))   # exemplo de axis

axis(1,at=1:5,labels=c(5,7,10,11,20))
axis(2,cex.axis=2,las=2)

box(lwd=2,lty=2)

###

curve(x^2,-1,1)   # exemplo de curve

abline(h=0.5,lty=2,lwd=5,col="firebrick")

abline(v=0,lty=4,lwd=5,col="goldenrod")

abline(a=0.5,b=1,lty=3,lwd=5,col="green4")

curve(sin(5*x)/5+0.5,add=TRUE,lty=2,lwd=5)

segments(-0.5,0.1,0.2,0.4,lwd=6,col="light blue")

###

plot(0,xlim=c(-2,2),ylim=c(-2,2),type="n")
polygon(c(-1,1,1,-1),c(-1,-1,1,1),col="gray50")

###

x <- matrix(rnorm(10000),100,100)   # 100 amostras de tamanho 100 da normal padro

media <- rep(NA,length=10)
inf <- rep(NA,length=10)
sup <- rep(NA,length=10)

for(i in 1:10){
  media[i] <- mean(x[i,])
  inf[i] <- quantile(x[i,],0.25)
  sup[i] <- quantile(x[i,],0.75)
}

plot(media,type="n",ylim=c(min(inf),max(sup)))
polygon(c(1:10,10:1),c(inf,sup[10:1]),col="light blue",border=FALSE)
lines(media,lwd=2)

###

x <- seq(-10,10,length=40)   # exemplos de superfcie
y <- seq(-10,10,length=40)
z <- matrix(NA,40,40)

for(i in 1:40){
  for(j in 1:40){
    z[i,j] <- x[i]^2 + y[j]^2
  }
}

contour(x,y,z)   # curva de nvel

image(x,y,z)   # grfico de imagem

persp(x,y,z)   # grfico de perspectiva

filled.contour(x,y,z)   # grfico de imagem suavizado

###

x <- seq(-10,10,length=40)
y <- seq(-10,10,length=40)
z <- matrix(NA,40,40)

for(i in 1:40){
  for(j in 1:40){
    z[i,j] <- sin(x[i]) + cos(y[j])
  }
}

contour(x,y,z)

image(x,y,z)

persp(x,y,z)

filled.contour(x,y,z)

persp(x,y,z,phi=55,theta=35,col=heat.colors(40*40),shade=0.1,border=TRUE)

for(i in 1:10000){
  persp(x,y,z,phi=i,theta=i,col=heat.colors(40*40),shade=0.1,border=TRUE)
}

###

savePlot("meugrafico.pdf",type="pdf")

# pacotes

library(MASS)

mu <- c(1,2,3)
Sigma <- matrix(c(2,1,2,1,3,1,2,1,4),3,3)

x <- mvrnorm(1,mu,Sigma)   # gerando da normal multivariada

###

n <- 30   # simulando um processo gaussiano no quadrado [0,1]

x <- seq(0,1,length=n)
y <- seq(0,1,length=n)

grade <- expand.grid(x,y)   # cria uma grade com base em vetores

d <- as.matrix(dist(grade,diag=TRUE,upper=TRUE))   # criando matriz de distncias

Sigma <- exp(-d/100)   # matriz de covarincia

mu <- rep(0,length=n^2)   # vetor de mdia

zvec <- mvrnorm(1,mu,Sigma)   # sorteando da normal multivariada

z <- matrix(zvec,n,n)   # desempilhando valores sorteados

image(x,y,z)

persp(x,y,z,theta=55,phi=35,col="light blue")

###

library(maptools)

mapa1 <- readShapePoly("states")   # lendo shape file

mapa2 <- readShapePoly("Canada")   # lendo shape file
